import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import de.bezier.data.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class imageTest extends PApplet {




int[] Xs = new int [50];
int[] Ys = new int [50];

int numD = 11;
int NameNo = 10;

String[] Names = new String[numD];
float[] sAgree = new float[numD];
float[] agree = new float[numD];
float[] neutral = new float[numD];
float[] disagree = new float[numD];
float[] sDisagree = new float[numD];


XlsReader reader;

// total no of images
int numImages = 11;
int bgImages = 10;
// image name array
PImage[] img = new PImage[numImages];
PImage[] bgImg = new PImage[bgImages];

PImage backgroundImage;

PFont myFont;
// x position you want
float mapX = 0;
// y position you want
float mapY = 0;
// map width you want
float mapW = 500;
// map height you want
float mapH = 500;
// var for current roll over
int rollover;

int bp = 35;
int spacing = 10;
int bw = 18; // bar witdh (buildings)
int len = 20;
int bh = 120; // building height

// setup array for images 10

public void setup(){
  size(1000,600);
  myFont = createFont("BebasNeue.otf",30);
   reader = new XlsReader( this, "10_Jayson.xls" );
   
  mapX = width/2 - mapW/2;
  mapY = height/1.7f - mapH/2;
  // need this to read the image names into the array
  for(int i = 0; i < numImages; i++){ 
  img[i] = loadImage((i+1)+"_GP_Boundaries.png");
  }
  
  for(int i = 0; i < bgImages; i++){ 
  bgImg[i] = loadImage((i+1)+"_bg.jpg");
  backgroundImage = loadImage((i+1)+"_bg.jpg");
  } 

  // pulling responses in exact numbers
  for (int row  = 38; row < 49; row++){
     Names[row-38] = reader.getString(row,2);
     sAgree[row-38] =((reader.getFloat(row,3)/reader.getFloat(row,8))*100);
     agree[row-38] = ((reader.getFloat(row,4)/reader.getFloat(row,8))*100);
     neutral[row-38] = ((reader.getFloat(row,5)/reader.getFloat(row,8))*100);
     disagree[row-38] = ((reader.getFloat(row,6)/reader.getFloat(row,8))*100);
     sDisagree[row-38] = ((reader.getFloat(row,7)/reader.getFloat(row,8))*100);
  

     sAgree[row-38] = rounded(sAgree[row-38], 2);
     agree[row-38] = rounded(agree[row-38], 2);
     neutral[row-38] = rounded(neutral[row-38], 2);
     disagree[row-38] = rounded(disagree[row-38], 2);
     sDisagree[row-38]  = rounded(sDisagree[row-38], 2);
}
  println(Names[10]);
  
 
}

public void draw(){
  strokeWeight(0);
  tint(255);
  image (backgroundImage,0,0);
  
  fill(0);
  rect( 752,0,220,600);
  fill(232,143,12,180);
  rect( 60,140,200,320);
  
  fill(255);
  textFont (myFont);
  text (" DOES OUR PROVINCE TRUST ITSELF?",5, 30);
  
  textSize(33);//text("A VISUALISATION OF THE RESPONSES TO THE QUESTION ASKED IN THE GCRO QUALITY OF LIFE SURVEY:", 10,60);
  text( "'BLACK PEOPLE AND WHITE PEOPLE WILL NEVER REALLY TRUST EACH OTHER' ", 10,90);
  textSize(24);
  text("A VISUALISATION OF THE RESPONSES TO THE STATEMENT MADE IN THE GCRO QUALITY OF LIFE SURVEY:", 10,55);
  
  
  if(NameNo < 11 ){
    textSize(28);
    if(NameNo == 10){
      text(" ",760,250);
    } else {
  text(Names[NameNo],760,250);
  textSize(18);
  text(sDisagree[NameNo]+" %",900,350);
  text(disagree[NameNo]+" %",900,380);
  text(neutral[NameNo]+" %",900,410);
  text(agree[NameNo]+" %",900,440);
  text(sAgree[NameNo]+" %",900,470);
   }
 
  textSize(18);
  text("Strongly Disagree",760,350);
  text("Disagree",760,380);
  text("Neutral",760,410);
  text("Agree",760,440);
  text("Strongly Agree",760,470);
  
    
  } 
  
 pushMatrix();
  translate(bp+ 40, 300);
   fill(0);
    rect(0, 0, bw, sDisagree[NameNo]*-3);
    rect(0 + 40, 0, bw,  disagree[NameNo]*-3);
    rect(0 + 80, 0, bw,  neutral[NameNo]*-3);
    rect(0 + 120, 0, bw, agree[NameNo]*-3);
    rect(0 + 160, 0, bw, sAgree[NameNo]*-3);
  rotate(HALF_PI);
  fill(255);
  smooth();
  textSize(18);
  text("Strongly Disagree",10,-2);
  text("Disagree",10, -42);
  text("Neutral",10, -82);
  text("Agree",10, -122);
  text("Strongly Agree",10, -162);
  popMatrix(); 
  

switch (rollover) {
  case 0:
  backgroundImage = bgImg[0];
  NameNo = 9;
  break;
  
  case 1:
   backgroundImage = bgImg[1];
   NameNo = 3;
  break;
  
   case 2:
    backgroundImage = bgImg[2];
    NameNo = 8;
  break;
  
   case 3:
    backgroundImage = bgImg[3];
    NameNo = 7;
  break;
  
   case 4:
    backgroundImage = bgImg[4];
    NameNo = 2;
  break;
  
   case 5:
    backgroundImage = bgImg[5];
    NameNo = 1;
  break;
  
   case 6:
    backgroundImage = bgImg[6];
    NameNo = 0;
  break;
 
  case 7:
   backgroundImage = bgImg[7];
   NameNo = 5;
  break;
  
   case 8:
    backgroundImage = bgImg[8];
    NameNo = 4;
  break;
  
   case 9:
    backgroundImage = bgImg[9];
    NameNo = 6;
  break;
  
  default:     
   NameNo = 10;
   backgroundImage = bgImg[0];
  break;
}

map(mapX,mapY,mapW,mapH);

}

// map function
public void map(float mx,float my,float mw,float mh){



int myTint = color(255,255,255,0);
// roll overs based on mx, my, mh, mw - so that you can change the placement and size easily
// so don't change these - only mx, my, mw and mh
if(mouseX > mx+(mw/2) && mouseX < mx+mw && mouseY > my && mouseY < my+(mh/2.4f) ){
  rollover = 0;
  myTint = color (232, 44,12, 150);
  
} 

if(mouseX > mx+(mw/5.7f) && mouseX < mx+(mw/2.6f) && mouseY > my+(mh/2.5f) && mouseY < my+(mh/1.9f) ){
  rollover = 1;
   myTint = color (245, 107,0, 150);
} 

if(mouseX > mx+(mw/2.6f) && mouseX < mx+(mw/2) && mouseY > my+(mh/2.4f) && mouseY < my+(mh/1.5f) ){ 
  rollover = 2;
   myTint = color (130, 25,7, 150);
} 

if(mouseX > mx+(mw/2) && mouseX < mx+(mw/1.4f) && mouseY > my+(mh/2.4f) && mouseY < my+(mh/1.5f) ){ 
  rollover = 3;
    myTint = color (232, 44,12, 150);
} 

if(mouseX > mx+(mw/1.8f) && mouseX < mx+(mw/1.16f) && mouseY > my+(mh/1.65f) && mouseY < my+(mh/1.2f) ){ 
  rollover = 4;
   myTint = color (245, 107,0, 150);
} 

if(mouseX > mx+(mw/2.6f) && mouseX < mx+(mw/1.8f) && mouseY > my+(mh/1.4f) && mouseY < my+(mh) ){ 
  rollover = 5;
   myTint = color (130, 25,7, 150);
} 
 
if(mouseX > mx+(mw/3.7f) && mouseX < mx+(mw/2.6f) && mouseY > my+(mh/1.35f) && mouseY < my+(mh/1.1f) ){ 
  rollover = 6;
    myTint = color (232, 44,12, 150);
} 

if(mouseX > mx+(mw/4.7f) && mouseX < mx+(mw/3.7f) && mouseY > my+(mh/1.55f) && mouseY < my+(mh/1.3f) ){ 
  rollover = 7;
   myTint = color (245, 107,0, 150);
} 


if(mouseX > mx+(mw/5.5f) && mouseX < mx+(mw/3.5f) && mouseY > my+(mh/1.9f) && mouseY < my+(mh/1.6f) ){ 
  rollover = 8;
   myTint = color (130, 25,7, 150);
} 

if(mouseX > mx && mouseX < mx+(mw/5) && mouseY > my+(mh/1.8f) && mouseY < my+(mh/1.2f) ){ 
  rollover = 9;
   myTint = color (232, 44,12, 150);
} 

// if not in the map space
if(mouseX >= mw+mx || mouseX <= mx ||  mouseY >= mh+my || mouseY <= my){
  rollover = 10;
   myTint = color (245, 107,0, 150);
} 


tint(200,200,200,160);
// base map size
img[10].resize(PApplet.parseInt(mw),PApplet.parseInt(mh));
// base map position
image(img[10],mx,my);

// points to the current roll over
if(rollover <= 9){
  // tinted light blue (you can add alpha if you want
tint(myTint);
//tint(64,202,219);
// resize the same as base map
img[rollover].resize(PApplet.parseInt(mw), PApplet.parseInt(mh));
// position the same as base map
image(img[rollover],mx,my);
}

}

public float rounded(float val, int dp)
{
  return PApplet.parseInt(val*pow(10,dp))/pow(10,dp);
} 
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "imageTest" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
